--- chan_unistim.c.orig	2011-10-11 11:33:06.000000000 -0500
+++ chan_unistim.c	2011-10-11 11:42:22.000000000 -0500
@@ -3733,157 +4525,151 @@
 
 	if (unistimdebug)
 		ast_verb(3, "unistim_call(%s)\n", ast->name);
-
 	session->state = STATE_RINGING;
-	Sendicon(TEXT_LINE0, FAV_ICON_NONE, session);
-
-	if (sub->owner) {
-		if (sub->owner->connected.id.number.valid
-			&& sub->owner->connected.id.number.str) {
-			if (session->device->height == 1) {
-				send_text(TEXT_LINE0, TEXT_NORMAL, session, sub->owner->connected.id.number.str);
-			} else {
-				send_text(TEXT_LINE1, TEXT_NORMAL, session, sub->owner->connected.id.number.str);
-			}
-			change_callerid(session, 0, sub->owner->connected.id.number.str);
+	send_callerid_screen(session, sub);
+	if (ast_strlen_zero(ast->call_forward)) { /* Send ring only if no call forward, otherwise short ring will apear */
+		send_text(TEXT_LINE2, TEXT_NORMAL, session, ustmtext("is calling you.", session));
+		send_text_status(session, ustmtext("Accept        Ignore Hangup", session));
+
+		if (sub_real) {
+			ringstyle = session->device->cwstyle;
+			ringvolume = session->device->cwvolume;
 		} else {
-			if (session->device->height == 1) {
-				send_text(TEXT_LINE0, TEXT_NORMAL, session, DEFAULTCALLERID);
-			} else {
-				send_text(TEXT_LINE1, TEXT_NORMAL, session, DEFAULTCALLERID);
-			}
-			change_callerid(session, 0, DEFAULTCALLERID);
+			ringstyle = (sub->ringstyle == -1) ? session->device->ringstyle : sub->ringstyle;
+			ringvolume = (sub->ringvolume == -1) ? session->device->ringvolume : sub->ringvolume;
 		}
-		if (sub->owner->connected.id.name.valid
-			&& sub->owner->connected.id.name.str) {
-			send_text(TEXT_LINE0, TEXT_NORMAL, session, sub->owner->connected.id.name.str);
-			change_callerid(session, 1, sub->owner->connected.id.name.str);
-		} else {
-			send_text(TEXT_LINE0, TEXT_NORMAL, session, DEFAULTCALLERNAME);
-			change_callerid(session, 1, DEFAULTCALLERNAME);
+		send_ring(session, ringvolume, ringstyle);
+		change_favorite_icon(session, FAV_ICON_SPEAKER_ONHOOK_BLACK + FAV_BLINK_FAST);
+		/* Send call identification to all */
+		for (i = 0; i < FAVNUM; i++) {
+			if (!soft_key_visible(session->device, i))
+				continue;
+			if (session->device->ssub[i])
+				continue;
+			if (is_key_line(session->device, i) && !strcmp(sub->parent->name, session->device->sline[i]->name)) {
+				if (unistimdebug)
+					ast_verb(0, "Found softkey %d for line %s\n", i, sub->parent->name);
+				send_favorite_short(i, FAV_ICON_SPEAKER_ONHOOK_BLACK + FAV_BLINK_FAST, session);
+				session->device->ssub[i] = sub;
+			}
 		}
 	}
-	send_text(TEXT_LINE2, TEXT_NORMAL, session, "is calling you.");
-	send_text_status(session, "Accept              Ignore");
-
-	if (sub->ringstyle == -1)
-		send_ring(session, session->device->ringvolume, session->device->ringstyle);
-	else {
-		if (sub->ringvolume == -1)
-			send_ring(session, session->device->ringvolume, sub->ringstyle);
-		else
-			send_ring(session, sub->ringvolume, sub->ringstyle);
-	}
-	change_favorite_icon(session, FAV_ICON_SPEAKER_ONHOOK_BLACK + FAV_BLINK_FAST);
-
 	ast_setstate(ast, AST_STATE_RINGING);
 	ast_queue_control(ast, AST_CONTROL_RINGING);
 	return res;
 }
 
+static int unistim_hangup_clean(struct ast_channel *ast, struct unistim_subchannel *sub) {
+	ast_mutex_lock(&sub->lock);
+	ast->tech_pvt = NULL;
+	sub->owner = NULL;
+	sub->alreadygone = 0;
+	ast_mutex_unlock(&sub->lock);
+	if (sub->rtp) {
+		if (unistimdebug)
+			ast_verb(0, "Destroying RTP session\n");
+		ast_rtp_instance_destroy(sub->rtp);
+		sub->rtp = NULL;
+	}
+	return 0;
+}
+
 /*--- unistim_hangup: Hangup UNISTIM call */
 static int unistim_hangup(struct ast_channel *ast)
 {
-	struct unistim_subchannel *sub;
+	struct unistim_subchannel *sub = NULL, *sub_real = NULL, *sub_trans = NULL;
 	struct unistim_line *l;
+	struct unistim_device *d;
 	struct unistimsession *s;
+	int i;
 
 	s = channel_to_session(ast);
 	sub = ast->tech_pvt;
+	l = sub->parent;
+	d = l->parent;
 	if (!s) {
 		ast_debug(1, "Asked to hangup channel not connected\n");
-		ast_mutex_lock(&sub->lock);
-		sub->owner = NULL;
-		ast->tech_pvt = NULL;
-		sub->alreadygone = 0;
-		ast_mutex_unlock(&sub->lock);
-		if (sub->rtp) {
-			if (unistimdebug)
-				ast_verb(0, "Destroying RTP session\n");
-			ast_rtp_instance_destroy(sub->rtp);
-			sub->rtp = NULL;
-		}
+		unistim_hangup_clean(ast, sub);
 		return 0;
 	}
-	l = sub->parent;
+	refresh_all_favorite(s); /* Update favicons in case of DND keys */
 	if (unistimdebug)
-		ast_verb(0, "unistim_hangup(%s) on %s@%s\n", ast->name, l->name, l->parent->name);
-
-	if ((l->subs[SUB_THREEWAY]) && (sub->subtype == SUB_REAL)) {
+		ast_verb(0, "unistim_hangup(%s) on %s@%s (STATE_%s)\n", ast->name, l->name, l->parent->name, ptestate_tostr(s->state));
+	sub_trans = get_sub(d, SUB_THREEWAY);
+	if (sub_trans && (sub_trans->owner) && (sub->subtype == SUB_REAL) &&
+		(sub->alreadygone == 0)) {
 		if (unistimdebug)
-			ast_verb(0, "Real call disconnected while talking to threeway\n");
-		sub->owner = NULL;
-		ast->tech_pvt = NULL;
+			ast_verb(0, "Threeway call disconnected, switching to real call\n");
+		if (ast_bridged_channel(sub_trans->owner)) {
+			ast_moh_stop(ast_bridged_channel(sub_trans->owner));
+		}
+		sub_trans->moh = 0;
+		sub_trans->subtype = SUB_REAL;
+		swap_subs(sub_trans, sub);
+
+		send_text_status(s, ustmtext("       Transf        Hangup", s));
+		send_callerid_screen(s, sub_trans);
+		unistim_hangup_clean(ast, sub);
+		unistim_unalloc_sub(d, sub);
 		return 0;
 	}
-	if ((l->subs[SUB_REAL]->owner) && (sub->subtype == SUB_THREEWAY) &&
+	sub_real = get_sub(d, SUB_REAL);
+	if (sub_real && (sub_real->owner) && (sub->subtype == SUB_THREEWAY) &&
 		(sub->alreadygone == 0)) {
 		if (unistimdebug)
-			ast_verb(0, "threeway call disconnected, switching to real call\n");
-		send_text(TEXT_LINE0, TEXT_NORMAL, s, "Three way call canceled,");
-		send_text(TEXT_LINE1, TEXT_NORMAL, s, "switching back to");
-		send_text(TEXT_LINE2, TEXT_NORMAL, s, "previous call.");
-		send_text_status(s, "Hangup Transf");
-		ast_moh_stop(ast_bridged_channel(l->subs[SUB_REAL]->owner));
-		swap_subs(l, SUB_THREEWAY, SUB_REAL);
-		l->parent->moh = 0;
-		ast_mutex_lock(&sub->lock);
-		sub->owner = NULL;
-		ast->tech_pvt = NULL;
-		ast_mutex_unlock(&sub->lock);
-		unalloc_sub(l, SUB_THREEWAY);
+			ast_verb(0, "Real call disconnected, stay in call\n");
+      
+		send_text_status(s, ustmtext("       Transf        Hangup", s));
+		send_callerid_screen(s, sub_real);
+		unistim_hangup_clean(ast, sub);
+		unistim_unalloc_sub(d, sub);
 		return 0;
 	}
-	ast_mutex_lock(&sub->lock);
-	sub->owner = NULL;
-	ast->tech_pvt = NULL;
-	sub->alreadygone = 0;
-	ast_mutex_unlock(&sub->lock);
-	if (!s) {
-		if (unistimdebug)
-			ast_verb(0, "Asked to hangup channel not connected (no session)\n");
-		if (sub->rtp) {
-			if (unistimdebug)
-				ast_verb(0, "Destroying RTP session\n");
-			ast_rtp_instance_destroy(sub->rtp);
-			sub->rtp = NULL;
+
+	if (sub->subtype == SUB_REAL) {
+		sub_stop_silence(s, sub);
+		send_end_call(s); /* Send end call packet only if ending active call, in other way sound should be loosed */
+	} else if (sub->subtype == SUB_RING) {
+		send_no_ring(s);
+		for (i = 0; i < FAVNUM; i++) {
+			if (!soft_key_visible(s->device, i))
+				continue;
+			if (d->ssub[i] != sub)
+				continue;
+			if (is_key_line(d, i) && !strcmp(l->name, d->sline[i]->name)) {
+				send_favorite_short(i, FAV_LINE_ICON, s);
+				d->ssub[i] = NULL;
+			}
 		}
-		return 0;
 	}
-	if (sub->subtype == SUB_REAL) {
-		/* Stop the silence generator */
-		if (s->device->silence_generator) {
-			if (unistimdebug)
-				ast_verb(0, "Stopping silence generator\n");
-			if (sub->owner)
-				ast_channel_stop_silence_generator(sub->owner,
-												   s->device->silence_generator);
-			else
-				ast_log(LOG_WARNING,
-						"Trying to stop silence generator on a null channel !\n");
-			s->device->silence_generator = NULL;
+	sub->moh = 0;
+	if (sub->softkey >= 0)
+		send_favorite_short(sub->softkey, FAV_LINE_ICON, s);
+
+	/* Delete assign sub to softkey */
+	for (i = 0; i < FAVNUM; i++) {
+		if (d->ssub[i] == sub) {
+			d->ssub[i] = NULL;
+			break;
 		}
 	}
-	l->parent->moh = 0;
-	send_no_ring(s);
-	send_end_call(s);
-	if (sub->rtp) {
-		if (unistimdebug)
-			ast_verb(0, "Destroying RTP session\n");
-		ast_rtp_instance_destroy(sub->rtp);
-		sub->rtp = NULL;
-	} else if (unistimdebug)
-		ast_verb(0, "No RTP session to destroy\n");
-	if (l->subs[SUB_THREEWAY]) {
-		if (unistimdebug)
-			ast_verb(0, "Cleaning other subchannels\n");
-		unalloc_sub(l, SUB_THREEWAY);
+	refresh_all_favorite(s); /* Update favicons in case of DND keys */
+	if (s->state == STATE_RINGING && sub->subtype == SUB_RING) {
+		send_no_ring(s);
+		if (!ast_test_flag(ast, AST_FLAG_ANSWERED_ELSEWHERE) && ast->hangupcause != AST_CAUSE_ANSWERED_ELSEWHERE) {
+			d->missed_call++;
+			write_history(s, 'i', 1);
+		}
+		if (!sub_real) {
+			show_main_page(s);
+		}
 	}
-	if (s->state == STATE_RINGING)
-		cancel_dial(s);
-	else if (s->state == STATE_CALL)
+	if (s->state == STATE_CALL && sub->subtype == SUB_REAL) {
 		close_call(s);
-
+	}
+	sub->softkey = -1;
+	unistim_hangup_clean(ast, sub);
+	unistim_unalloc_sub(d, sub);
 	return 0;
 }
 
@@ -3893,6 +4679,7 @@
 	int res = 0;
 	struct unistim_subchannel *sub;
 	struct unistim_line *l;
+	struct unistim_device *d;
 	struct unistimsession *s;
 
 	s = channel_to_session(ast);
@@ -3902,18 +4689,19 @@
 	}
 	sub = ast->tech_pvt;
 	l = sub->parent;
+	d = l->parent;
 
-	if ((!sub->rtp) && (!l->subs[SUB_THREEWAY]))
+	if ((!sub->rtp) && (!get_sub(d, SUB_THREEWAY)))
 		start_rtp(sub);
 	if (unistimdebug)
 		ast_verb(0, "unistim_answer(%s) on %s@%s-%d\n", ast->name, l->name,
-					l->parent->name, sub->subtype);
-	send_text(TEXT_LINE2, TEXT_NORMAL, l->parent->session, "is now on-line");
-	if (l->subs[SUB_THREEWAY])
-		send_text_status(l->parent->session, "Transf Cancel");
+					l->parent->name, sub->softkey);
+	send_text(TEXT_LINE2, TEXT_NORMAL, s, ustmtext("is now on-line", s));
+	if (get_sub(d, SUB_THREEWAY))
+		send_text_status(s, ustmtext("Transf Cancel", s));
 	else
-		send_text_status(l->parent->session, "Hangup Transf");
-	send_start_timer(l->parent->session);
+		send_text_status(s, ustmtext("       Transf        Hangup", s));
+	send_start_timer(s);
 	if (ast->_state != AST_STATE_UP)
 		ast_setstate(ast, AST_STATE_UP);
 	return res;
@@ -3928,11 +4716,13 @@
 	int found = 0;
 	int tmp = 0;
 	int dw_num_bytes_rcvd;
+	unsigned int size_addr_from;
 #ifdef DUMP_PACKET
 	int dw_num_bytes_rcvdd;
 	char iabuf[INET_ADDRSTRLEN];
 #endif
 
+	size_addr_from = sizeof(addr_from);
 	dw_num_bytes_rcvd =
 		recvfrom(unistimsock, buff, SIZE_PAGE, 0, (struct sockaddr *) &addr_from,
 				 &size_addr_from);
@@ -4009,10 +4799,11 @@
 	if (sub->owner) {
 		/* We already hold the channel lock */
 		if (f->frametype == AST_FRAME_VOICE) {
-			if (f->subclass.codec != sub->owner->nativeformats) {
+			if (sub->owner->nativeformats != f->subclass.codec) {
+				char tmp[256];
 				ast_debug(1,
 						"Oooh, format changed from %s to %s\n",
-						ast_getformatname(sub->owner->nativeformats),
+						ast_getformatname_multiple(tmp, sizeof(tmp), sub->owner->nativeformats),
 						ast_getformatname(f->subclass.codec));
 
 				sub->owner->nativeformats = f->subclass.codec;
@@ -4051,7 +4842,7 @@
 			return 0;
 		}
 	} else {
-		if (!(frame->subclass.codec & ast->nativeformats)) {
+		if (!(ast->nativeformats & frame->subclass.codec)) {
 			char tmp[256];
 			ast_log(LOG_WARNING,
 					"Asked to transmit frame type %s, while native formats is %s (read/write = (%s/%s)\n",
@@ -4127,6 +4918,12 @@
 		return "Key Radio";
 	case AST_CONTROL_RADIO_UNKEY:
 		return "Un-Key Radio";
+	case AST_CONTROL_CONNECTED_LINE:
+		return "Remote end changed";
+	case AST_CONTROL_SRCCHANGE:
+		return "RTP source updated";
+	case AST_CONTROL_SRCUPDATE:
+		return "Source of media changed";
 	case -1:
 		return "Stop tone";
 	}
@@ -4154,8 +4951,8 @@
 	struct unistimsession *s;
 
 	if (unistimdebug) {
-		ast_verb(3, "Asked to indicate '%s' condition on channel %s\n",
-					control2str(ind), ast->name);
+		ast_verb(3, "Asked to indicate '%s' (%d) condition on channel %s\n",
+					control2str(ind), ind, ast->name);
 	}
 
 	s = channel_to_session(ast);
@@ -4168,7 +4965,7 @@
 	switch (ind) {
 	case AST_CONTROL_RINGING:
 		if (ast->_state != AST_STATE_UP) {
-			send_text(TEXT_LINE2, TEXT_NORMAL, s, "Ringing...");
+			send_text(TEXT_LINE2, TEXT_NORMAL, s, ustmtext("Ringing...", s));
 			in_band_indication(ast, l->parent->tz, "ring");
 			s->device->missed_call = -1;
 			break;
@@ -4177,7 +4974,7 @@
 	case AST_CONTROL_BUSY:
 		if (ast->_state != AST_STATE_UP) {
 			sub->alreadygone = 1;
-			send_text(TEXT_LINE2, TEXT_NORMAL, s, "Busy");
+			send_text(TEXT_LINE2, TEXT_NORMAL, s, ustmtext("Busy", s));
 			in_band_indication(ast, l->parent->tz, "busy");
 			s->device->missed_call = -1;
 			break;
@@ -4190,7 +4987,7 @@
 	case AST_CONTROL_CONGESTION:
 		if (ast->_state != AST_STATE_UP) {
 			sub->alreadygone = 1;
-			send_text(TEXT_LINE2, TEXT_NORMAL, s, "Congestion");
+			send_text(TEXT_LINE2, TEXT_NORMAL, s, ustmtext("Congestion", s));
 			in_band_indication(ast, l->parent->tz, "congestion");
 			s->device->missed_call = -1;
 			break;
@@ -4204,12 +5001,22 @@
 		break;
 	case AST_CONTROL_PROGRESS:
 	case AST_CONTROL_SRCUPDATE:
+	case AST_CONTROL_PROCEEDING:
 		break;
 	case -1:
 		ast_playtones_stop(ast);
 		s->device->missed_call = 0;
 		break;
-	case AST_CONTROL_PROCEEDING:
+        case AST_CONTROL_CONNECTED_LINE:
+		ast_log(LOG_NOTICE, "Connected party is now %s <%s>\n",
+		S_COR(ast->connected.id.name.valid, ast->connected.id.name.str, ""),
+		S_COR(ast->connected.id.number.valid, ast->connected.id.number.str, ""));
+		if (sub->subtype == SUB_REAL) {
+			send_callerid_screen(s, sub);
+		}
+		break;
+	case AST_CONTROL_SRCCHANGE:
+		ast_rtp_instance_change_source(sub->rtp);
 		break;
 	default:
 		ast_log(LOG_WARNING, "Don't know how to indicate condition %d\n", ind);
@@ -4223,6 +5030,7 @@
 {
 	struct unistim_line *l;
 	struct unistim_device *d;
+	struct unistim_subchannel *sub = NULL;
 	char line[256];
 	char *at;
 	char *device;
@@ -4246,12 +5054,22 @@
 			if (unistimdebug)
 				ast_verb(0, "Found device: %s\n", d->name);
 			/* Found the device */
-			l = d->lines;
-			while (l) {
+			AST_LIST_LOCK(&d->lines);
+			AST_LIST_TRAVERSE(&d->lines, l, list) {
 				/* Search for the right line */
 				if (!strcasecmp(l->name, line)) {
-					l->subs[SUB_REAL]->ringvolume = -1;
-					l->subs[SUB_REAL]->ringstyle = -1;
+					if (unistimdebug)
+						ast_verb(0, "Found line: %s\n", l->name);
+					sub = get_sub(d, SUB_REAL);
+					if (!sub) {
+						sub = unistim_alloc_sub(d, SUB_REAL);
+					}
+					if (sub->owner) {
+						/* Allocate additional channel if asterisk channel already here */
+						sub = unistim_alloc_sub(d, SUB_ONHOLD);
+					}
+					sub->ringvolume = -1;
+					sub->ringstyle = -1;
 					if (at) {       /* Other options ? */
 						at++;   /* Skip slash */
 						if (*at == 'r') {       /* distinctive ring */
@@ -4267,15 +5085,19 @@
 								if (unistimdebug)
 									ast_verb(0, "Distinctive ring : style #%d volume %d\n",
 										 ring_style, ring_volume);
-								l->subs[SUB_REAL]->ringvolume = ring_volume;
-								l->subs[SUB_REAL]->ringstyle = ring_style;
+								sub->ringvolume = ring_volume;
+								sub->ringstyle = ring_style;
 							}
 						}
 					}
-					ast_mutex_unlock(&devicelock);
-					return l->subs[SUB_REAL];
+					sub->parent = l;
+					break;
 				}
-				l = l->next;
+			}
+			AST_LIST_UNLOCK(&d->lines);
+			if (sub) {
+				ast_mutex_unlock(&devicelock);
+				return sub;
 			}
 		}
 		d = d->next;
@@ -4302,9 +5124,9 @@
 	struct ast_frame f = { 0, };
 	struct unistim_subchannel *sub;
 
-	sub = pte->device->lines->subs[SUB_REAL];
+	sub = get_sub(pte->device, SUB_REAL);
 
-	if (!sub->owner || sub->alreadygone) {
+	if (!sub || !sub->owner || sub->alreadygone) {
 		ast_log(LOG_WARNING, "Unable to find subchannel in dtmf senddigit_end\n");
 		return -1;
 	}
@@ -4437,7 +5259,7 @@
 		if (pte->device->height == 1) {
 			send_text(TEXT_LINE0, TEXT_NORMAL, pte, text);
 		} else {
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Message :");
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext("Message :", pte));
 			send_text(TEXT_LINE1, TEXT_NORMAL, pte, text);
 		}
 		if (size <= TEXT_LENGTH_MAX) {
@@ -4460,18 +5282,17 @@
 }
 
 /*--- unistim_send_mwi_to_peer: Send message waiting indication ---*/
-static int unistim_send_mwi_to_peer(struct unistimsession *s, unsigned int tick)
+static int unistim_send_mwi_to_peer(struct unistim_line *peer, unsigned int tick)
 {
 	struct ast_event *event;
 	int new;
 	char *mailbox, *context;
-	struct unistim_line *peer = s->device->lines;
-
+	
 	context = mailbox = ast_strdupa(peer->mailbox);
 	strsep(&context, "@");
 	if (ast_strlen_zero(context))
 		context = "default";
-
+	
 	event = ast_event_get_cached(AST_EVENT_MWI,
 		AST_EVENT_IE_MAILBOX, AST_EVENT_IE_PLTYPE_STR, mailbox,
 		AST_EVENT_IE_CONTEXT, AST_EVENT_IE_PLTYPE_STR, context,
@@ -4490,13 +5311,9 @@
 	if (new == peer->lastmsgssent) {
 		return 0;
 	}
-
+	
 	peer->lastmsgssent = new;
-	if (new == 0) {
-		send_led_update(s, 0);
-	} else {
-		send_led_update(s, 1);
-	}
+	send_led_update(peer->parent->session, (new > 0));
 
 	return 0;
 }
@@ -4519,9 +5336,9 @@
 	}
 	l = sub->parent;
 	tmp = ast_channel_alloc(1, state, l->cid_num, NULL, l->accountcode, l->exten,
-		l->context, linkedid, l->amaflags, "%s@%s-%d", l->name, l->parent->name, sub->subtype);
+		l->parent->context, linkedid, l->amaflags, "USTM/%s@%s-%p", l->name, l->parent->name, sub);
 	if (unistimdebug)
-		ast_verb(0, "unistim_new sub=%d (%p) chan=%p\n", sub->subtype, sub, tmp);
+		ast_verb(0, "unistim_new sub=%d (%p) chan=%p line=%s\n", sub->subtype, sub, tmp, l->name);
 	if (!tmp) {
 		ast_log(LOG_WARNING, "Unable to allocate channel structure\n");
 		return NULL;
@@ -4559,12 +5376,9 @@
 	tmp->rawreadformat = fmt;
 	tmp->tech_pvt = sub;
 	tmp->tech = &unistim_tech;
-	if (!ast_strlen_zero(l->language))
-		ast_string_field_set(tmp, language, l->language);
+	if (!ast_strlen_zero(l->parent->language))
+		ast_string_field_set(tmp, language, l->parent->language);
 	sub->owner = tmp;
-	ast_mutex_lock(&usecnt_lock);
-	usecnt++;
-	ast_mutex_unlock(&usecnt_lock);
 	ast_update_use_count();
 	tmp->callgroup = l->callgroup;
 	tmp->pickupgroup = l->pickupgroup;
@@ -4640,11 +5454,19 @@
 				dw_timeout = cur->timeout - tick;
 			/* Checking if the phone is logged on for a new MWI */
 			if (cur->device) {
-				if ((!ast_strlen_zero(cur->device->lines->mailbox)) &&
-					((tick >= cur->device->lines->nextmsgcheck))) {
-					DEBUG_TIMER("Checking mailbox for MWI\n");
-					unistim_send_mwi_to_peer(cur, tick);
-					break;
+				struct unistim_line *l;
+				AST_LIST_LOCK(&cur->device->lines);
+				AST_LIST_TRAVERSE(&cur->device->lines, l, list) {
+					if ((!ast_strlen_zero(l->mailbox)) && (tick >= l->nextmsgcheck)) {
+						DEBUG_TIMER("Checking mailbox for MWI\n");
+						unistim_send_mwi_to_peer(l, tick);
+						break;
+					}
+				}
+				AST_LIST_UNLOCK(&cur->device->lines);
+				if (cur->device->nextdial && tick >= cur->device->nextdial) {
+					handle_call_outgoing(cur);
+					cur->device->nextdial = 0;
 				}
 			}
 			cur = cur->next;
@@ -4711,18 +5533,14 @@
 										   int *cause)
 {
 	format_t oldformat;
-	struct unistim_subchannel *sub;
+	struct unistim_subchannel *sub, *sub_ring, *sub_trans;
+	struct unistim_device *d;
 	struct ast_channel *tmpc = NULL;
 	char tmp[256];
 	char *dest = data;
 
 	oldformat = format;
 	format &= CAPABILITY;
-	ast_log(LOG_NOTICE,
-			"Asked to get a channel of format %s while capability is %s result : %s\n",
-			ast_getformatname(oldformat),
-			ast_getformatname_multiple(tmp, sizeof(tmp), CAPABILITY),
-			ast_getformatname(format));
 	if (!format) {
 		ast_log(LOG_NOTICE,
 				"Asked to get a channel of unsupported format %s while capability is %s\n",
@@ -4735,22 +5553,37 @@
 		ast_log(LOG_NOTICE, "Unistim channels require a device\n");
 		return NULL;
 	}
-
 	sub = find_subchannel_by_name(tmp);
 	if (!sub) {
 		ast_log(LOG_NOTICE, "No available lines on: %s\n", dest);
 		*cause = AST_CAUSE_CONGESTION;
 		return NULL;
 	}
-
-	ast_verb(3, "unistim_request(%s)\n", tmp);
-	/* Busy ? */
-	if (sub->owner) {
+	d = sub->parent->parent;
+	sub_ring = get_sub(d, SUB_RING);
+	sub_trans = get_sub(d, SUB_THREEWAY);
+	/* Another request already in progress */
+	if (!d->session) {
+		unistim_unalloc_sub(d, sub);
+		*cause = AST_CAUSE_CONGESTION;
+		return NULL;
+	}
+	if (sub_ring || sub_trans) {
+		if (unistimdebug)
+			ast_verb(0, "Can't create channel, request already in progress: Busy!\n");
+		unistim_unalloc_sub(d, sub);
+		*cause = AST_CAUSE_BUSY;
+		return NULL;
+	}
+        if (get_avail_softkey(d->session, sub->parent->name) == -1) {
 		if (unistimdebug)
-			ast_verb(0, "Can't create channel : Busy !\n");
+			ast_verb(0, "Can't create channel for line %s, all lines busy\n", sub->parent->name);
+		unistim_unalloc_sub(d, sub);
 		*cause = AST_CAUSE_BUSY;
 		return NULL;
 	}
+	sub->subtype = SUB_RING;
+	sub->softkey = -1;
 	sub->parent->capability = format;
 	tmpc = unistim_new(sub, AST_STATE_DOWN, requestor ? requestor->linkedid : NULL);
 	if (!tmpc)
@@ -4763,13 +5596,12 @@
 	return tmpc;
 }
 
-static char *unistim_info(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
+static char *unistim_show_info(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
 {
 	struct unistim_device *device = devices;
 	struct unistim_line *line;
 	struct unistim_subchannel *sub;
 	struct unistimsession *s;
-	int i;
 	struct ast_channel *tmp;
 
 	switch (cmd) {
@@ -4777,7 +5609,11 @@
 		e->command = "unistim show info";
 		e->usage =
 			"Usage: unistim show info\n" 
-			"       Dump internal structures.\n";
+			"       Dump internal structures.\n\n"
+			"       device\n"
+			"       ->line\n"
+			"       -->sub\n"
+			"       ==>key\n";
 		return NULL;
 
 	case CLI_GENERATE:
@@ -4787,45 +5623,59 @@
 	if (a->argc != e->args)
 		return CLI_SHOWUSAGE;
 
-	ast_cli(a->fd, "Dumping internal structures :\ndevice\n->line\n-->sub\n");
+	ast_cli(a->fd, "Dumping internal structures:\n");
+	ast_mutex_lock(&devicelock);
 	while (device) {
-		ast_cli(a->fd, "\nname=%s id=%s line=%p ha=%p sess=%p device=%p\n",
-				device->name, device->id, device->lines, device->ha, device->session,
-				device);
-		line = device->lines;
-		while (line) {
+		int i;
+
+		ast_cli(a->fd, "\nname=%s id=%s ha=%p sess=%p device=%p selected=%d height=%d\n",
+				device->name, device->id, device->ha, device->session,
+				device, device->selected, device->height);
+		AST_LIST_LOCK(&device->lines);
+		AST_LIST_TRAVERSE(&device->lines,line,list) {
+			char tmp2[256];
 			ast_cli(a->fd,
-					"->name=%s fullname=%s exten=%s callid=%s cap=%" PRId64 " device=%p line=%p\n",
+					"->name=%s fullname=%s exten=%s callid=%s cap=%s line=%p\n",
 					line->name, line->fullname, line->exten, line->cid_num,
-					line->capability, line->parent, line);
-			for (i = 0; i < MAX_SUBS; i++) {
-				sub = line->subs[i];
-				if (!sub)
-					continue;
-				if (!sub->owner)
-					tmp = (void *) -42;
-				else
-					tmp = sub->owner->_bridge;
-				if (sub->subtype != i)
-					ast_cli(a->fd, "Warning ! subchannel->subs[%d] have a subtype=%d\n", i,
-							sub->subtype);
-				ast_cli(a->fd,
-						"-->subtype=%d chan=%p rtp=%p bridge=%p line=%p alreadygone=%d\n",
-						sub->subtype, sub->owner, sub->rtp, tmp, sub->parent,
-						sub->alreadygone);
+					ast_getformatname_multiple(tmp2, sizeof(tmp2), line->capability), line);
+		}
+		AST_LIST_UNLOCK(&device->lines);
+                
+		AST_LIST_LOCK(&device->subs);
+		AST_LIST_TRAVERSE(&device->subs, sub, list) {
+			if (!sub)
+				continue;
+			if (!sub->owner) {
+				tmp = (void *) -42;
+			} else {
+				tmp = sub->owner->_bridge;
+			}
+			ast_cli(a->fd,
+					"-->subtype=%s chan=%p rtp=%p bridge=%p line=%p alreadygone=%d softkey=%d\n",
+					subtype_tostr(sub->subtype), sub->owner, sub->rtp, tmp, sub->parent,
+					sub->alreadygone, sub->softkey);
+		}
+		AST_LIST_UNLOCK(&device->subs);
+
+		for (i = 0; i < FAVNUM; i++) {
+			if (!soft_key_visible(device, i)) {
+				continue;
 			}
-			line = line->next;
+			ast_cli(a->fd, "==> %d. dev=%s icon=%#-4x label=%-10s number=%-5s sub=%p line=%p\n",
+				i, device->softkeydevice[i], device->softkeyicon[i], device->softkeylabel[i], device->softkeynumber[i],
+				device->ssub[i], device->sline[i]);
 		}
 		device = device->next;
 	}
+	ast_mutex_unlock(&devicelock);
 	ast_cli(a->fd, "\nSessions:\n");
 	ast_mutex_lock(&sessionlock);
 	s = sessions;
 	while (s) {
 		ast_cli(a->fd,
-				"sin=%s timeout=%u state=%d macaddr=%s device=%p session=%p\n",
-				ast_inet_ntoa(s->sin.sin_addr), s->timeout, s->state, s->macaddr,
-				s->device, s);
+				"sin=%s timeout=%u state=%s macaddr=%s device=%s session=%p\n",
+				ast_inet_ntoa(s->sin.sin_addr), s->timeout, ptestate_tostr(s->state), s->macaddr,
+				s->device->name, s);
 		s = s->next;
 	}
 	ast_mutex_unlock(&sessionlock);
@@ -4833,6 +5683,38 @@
 	return CLI_SUCCESS;
 }
 
+static char *unistim_show_devices(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
+{
+	struct unistim_device *device = devices;
+
+	switch (cmd) {
+	case CLI_INIT:
+		e->command = "unistim show devices";
+		e->usage =
+			"Usage: unistim show devices\n"
+			"       Lists all known Unistim devices.\n";
+		return NULL;
+	case CLI_GENERATE:
+		return NULL;	/* no completion */
+	}
+
+	if (a->argc != e->args)
+		return CLI_SHOWUSAGE;
+
+	ast_cli(a->fd, "%-20.20s %-20.20s %-15.15s %s\n", "Name/username", "MAC", "Host", "Status");
+	ast_mutex_lock(&devicelock);
+	while (device) {
+		ast_cli(a->fd, "%-20.20s %-20.20s %-15.15s %s\n",
+			device->name, device->id, 
+			(!device->session) ? "(Unspecified)" : ast_inet_ntoa(device->session->sin.sin_addr),
+			(!device->session) ? "UNKNOWN" : "OK");
+		device = device->next;
+	}
+	ast_mutex_unlock(&devicelock);
+
+	return CLI_SUCCESS;
+}
+
 static char *unistim_sp(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
 {
 	BUFFSEND;
@@ -4943,22 +5825,15 @@
 	if (e && a && a->argc != e->args)
 		return CLI_SHOWUSAGE;
 
-	if (unistimdebug)
-		ast_verb(0, "reload unistim\n");
-
-	ast_mutex_lock(&unistim_reload_lock);
-	if (!unistim_reloading)
-		unistim_reloading = 1;
-	ast_mutex_unlock(&unistim_reload_lock);
-
-	restart_monitor();
+	reload();
 
 	return CLI_SUCCESS;
 }
 
 static struct ast_cli_entry unistim_cli[] = {
 	AST_CLI_DEFINE(unistim_reload, "Reload UNISTIM configuration"),
-	AST_CLI_DEFINE(unistim_info, "Show UNISTIM info"),
+	AST_CLI_DEFINE(unistim_show_info, "Show UNISTIM info"),
+	AST_CLI_DEFINE(unistim_show_devices, "Show UNISTIM devices"),
 	AST_CLI_DEFINE(unistim_sp, "Send packet (for reverse engineering)"),
 	AST_CLI_DEFINE(unistim_do_debug, "Toggle UNITSTIM debugging"),
 };
@@ -4982,7 +5857,7 @@
 	return;
 }
 
-static int ParseBookmark(const char *text, struct unistim_device *d)
+static int parse_bookmark(const char *text, struct unistim_device *d)
 {
 	char line[256];
 	char *at;
@@ -5057,7 +5932,7 @@
 	ast_copy_string(d->softkeylabel[p], line, sizeof(d->softkeylabel[p]));
 	ast_copy_string(d->softkeynumber[p], number, sizeof(d->softkeynumber[p]));
 	if (unistimdebug)
-		ast_verb(0, "New bookmark at pos %d label='%s' number='%s' icon=%x\n",
+		ast_verb(0, "New bookmark at pos %d label='%s' number='%s' icon=%#x\n",
 					p, d->softkeylabel[p], d->softkeynumber[p], d->softkeyicon[p]);
 	return 1;
 }
@@ -5067,6 +5942,7 @@
 {
 	struct unistim_device *d = devices;
 	int i;
+	ast_mutex_lock(&devicelock);
 	while (d) {
 		for (i = 0; i < 6; i++) {
 			if (d->softkeyicon[i] == 1) {   /* Something for us */
@@ -5086,17 +5962,31 @@
 		}
 		d = d->next;
 	}
+	ast_mutex_unlock(&devicelock);
+}
+
+static struct unistim_line *find_line_by_number(struct unistim_device *d, const char *val) {
+	struct unistim_line *l, *ret = NULL;
+
+	AST_LIST_LOCK(&d->lines);
+	AST_LIST_TRAVERSE(&d->lines, l, list) {
+		if (!strcmp(l->name, val)) {
+			ret = l;
+			break;
+		}
+	}
+	AST_LIST_UNLOCK(&d->lines);
+	return ret;
 }
 
 static struct unistim_device *build_device(const char *cat, const struct ast_variable *v)
 {
 	struct unistim_device *d;
-	struct unistim_line *l = NULL;
+	struct unistim_line *l = NULL, *lt = NULL;
 	int create = 1;
-	int nbsoftkey, dateformat, timeformat, callhistory;
+	int nbsoftkey, dateformat, timeformat, callhistory, sharpdial, linecnt;
 	char linelabel[AST_MAX_EXTENSION];
-	char context[AST_MAX_EXTENSION];
-	char ringvolume, ringstyle;
+	char ringvolume, ringstyle, cwvolume, cwstyle;
 
 	/* First, we need to know if we already have this name in our list */
 	/* Get a lock for the device chained list */
@@ -5113,36 +6003,58 @@
 			}
 			/* we're reloading right now */
 			create = 0;
-			l = d->lines;
 			break;
 		}
 		d = d->next;
 	}
+	if (!(lt = ast_calloc(1, sizeof(*lt)))) {
+		return NULL;
+	}
 	ast_mutex_unlock(&devicelock);
 	if (create) {
 		if (!(d = ast_calloc(1, sizeof(*d))))
 			return NULL;
-
-		if (!(l = ast_calloc(1, sizeof(*l)))) {
-			ast_free(d);
-			return NULL;
-		}
+		ast_mutex_init(&d->lock);
 		ast_copy_string(d->name, cat, sizeof(d->name));
-	}
-	ast_copy_string(context, DEFAULTCONTEXT, sizeof(context));
+	} else {
+		/* Delete existing line information */
+		AST_LIST_LOCK(&d->lines);
+		AST_LIST_TRAVERSE_SAFE_BEGIN(&d->lines, l, list){
+			AST_LIST_REMOVE_CURRENT(list);
+			unistim_line_destroy(l);
+		}
+		AST_LIST_TRAVERSE_SAFE_END
+		AST_LIST_UNLOCK(&d->lines);
+	}
+
+	/* reset bookmarks */
+	memset(d->softkeylabel, 0, sizeof(d->softkeylabel));
+	memset(d->softkeynumber, 0, sizeof(d->softkeynumber));
+	memset(d->softkeyicon, 0, sizeof(d->softkeyicon));
+	memset(d->softkeydevice, 0, sizeof(d->softkeydevice));
+	memset(d->ssub, 0, sizeof(d->ssub));
+	memset(d->sline, 0, sizeof(d->sline));
+	memset(d->sp, 0, sizeof(d->sp));
+        
+	ast_copy_string(d->context, DEFAULTCONTEXT, sizeof(d->context));
 	d->contrast = -1;
 	d->output = OUTPUT_HANDSET;
 	d->previous_output = OUTPUT_HANDSET;
 	d->volume = VOLUME_LOW;
 	d->mute = MUTE_OFF;
 	d->height = DEFAULTHEIGHT;
+	d->selected = -1;
 	linelabel[0] = '\0';
 	dateformat = 1;
 	timeformat = 1;
 	ringvolume = 2;
+	cwvolume = 1;
 	callhistory = 1;
+	sharpdial = 0;
 	ringstyle = 3;
+	cwstyle = 2;
 	nbsoftkey = 0;
+	linecnt = 0;
 	while (v) {
 		if (!strcasecmp(v->name, "rtp_port"))
 			d->rtp_port = atoi(v->value);
@@ -5157,7 +6069,7 @@
 		else if (!strcasecmp(v->name, "permit") || !strcasecmp(v->name, "deny"))
 			d->ha = ast_append_ha(v->name, v->value, d->ha, NULL);
 		else if (!strcasecmp(v->name, "context"))
-			ast_copy_string(context, v->value, sizeof(context));
+			ast_copy_string(d->context, v->value, sizeof(d->context));
 		else if (!strcasecmp(v->name, "maintext0"))
 			unquote(d->maintext0, v->value, sizeof(d->maintext0) - 1);
 		else if (!strcasecmp(v->name, "maintext1"))
